<?php
/* * ********************************************************************
*  ProxmoxVPS Product developed. (27.03.19)
* *
*
*  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
*  CONTACT                        ->       contact@modulesgarden.com
*
*
* This software is furnished under a license and may be used and copied
* only  in  accordance  with  the  terms  of such  license and with the
* inclusion of the above copyright notice.  This software  or any other
* copies thereof may not be provided or otherwise made available to any
* other person.  No title to and  ownership of the  software is  hereby
* transferred.
*
*
* ******************************************************************** */

namespace ModulesGarden\Servers\ProxmoxCloudVps\App\UI\MountPoint\Forms;

use ModulesGarden\ProxmoxAddon\App\Services\Cloud\ProductService;
use ModulesGarden\Servers\ProxmoxCloudVps\App\UI\MountPoint\Providers\MountPointProvider;
use ModulesGarden\Servers\ProxmoxCloudVps\App\UI\MountPoint\Validators\DiskSizeValidator;
use ModulesGarden\Servers\ProxmoxCloudVps\App\UI\Validators\NumberValidator;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Interfaces\ClientArea;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\BaseForm;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Hidden;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Switcher;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Text;

class UpdateForm extends BaseForm implements ClientArea
{
    use ProductService;

    public function initContent()
    {
        $this->initIds('updateDiskForm');
        $this->setFormType('update');
        $this->setProvider(new MountPointProvider());
        $this->initFields();
        $this->loadDataToForm();
    }

    public function getAllowedActions()
    {
        return ['update'];
    }

    private function initFields()
    {
        //entity id
        $this->addField(new Hidden("id"));
        //size
        $field = new Text('size');
        $field->addValidator(new DiskSizeValidator(true));
        $this->addField($field);
        //backup
        if ($this->configuration()->isPermissionMountPointBackup())
        {
            $field = new Switcher('backup');
            $this->addField($field);
        }

    }
}